/* REXX-PROGRAMM kmpl.CMD      */
   Call RxFuncAdd 'SysLoadFuncs', RexxUtil, 'SysLoadFuncs'
   Call SysLoadFuncs
   Call SysCls

   /* Wird bei der Ausfhrung einer REXX-Anweisung ein Syntaxfehler */
   /* festgestellt, so wird zur Prozedur "Fehlermeldung" verzweigt. */
   signal on syntax name kmplMsg 

 /* Mit den folgenden Zeilen wird, wenn das Verzeichnis, in dem sich diese */
 /* Datei  kmpl.CMD  befindet, im Pfad steht, sichergestellt, da auch die */
 /* Datei  kmpl.INF  bei Fehlern von kmpl.CMD angezeigt werden kann,       */
 /* wenn   kmpl.CMD  nicht aus diesem Verzeichnis aufgerufen wird.         */
   Pfd=SysSearchPath("PATH", "kmpl.cmd")
   lp=LastPos("\", Pfd)
   Pfd=DelStr(Pfd, 1+lp)

Anf:  
   call Locate 02,08
   call Charout,"Elementare Rechenoperationen mit zwei komplexen Zahlen"; say

   sch=0                          
   call Locate 04,04
   call CsrAttrib "High";  call Color "White"
   call Charout,"           Re1 + i*Im1"
   call CsrAttrib "Normal"
   call Charout," = "
lRe1:  
   call Locate 06,04
   call Charout,"                                                          "
   call Locate 06,04
   call Charout,"(1)     Realteil (Re1) = "; pull Re1
   if DataType(Re1, 'N')<>1 then
   do    
     Call Quatsch
     Call Loesch
     Call SysCurState ON
     signal lRe1
   end    
   if sch==1 then signal lkmpl1
lIm1:
   call Locate 07,04
   call Charout,"                                                          "
   call Locate 07,04
   call Charout,"(2) Imaginrteil (Im1) = "; pull Im1
   if DataType(Im1, 'N')<>1 then
   do    
     Call Quatsch
     Call Loesch
     Call SysCurState ON
     signal lIm1
   end    
lkmpl1:                                 
   svz1="+"
   if Im1>0 then do; svz1="+"; vz1=+1; end
   if Im1<0 then do; svz1="-"; vz1=-1; end
   call Locate 04,29
   if Im1==0 then ImIm1=0; else ImIm1=vz1*Im1
   z1=Re1||" "||svz1||" i*"||ImIm1
   call CsrAttrib "High";   call Color "White"  
   call Charout,"                                               "
   call Locate 04,29
   call Charout,z1
   call CsrAttrib "Normal"
   if sch==1 then Signal sel 

   sch=0 
   call Locate 09,04
   call CsrAttrib "High";  call Color "White"
   call Charout,"           Re2 + i*Im2"
   call CsrAttrib "Normal"
   call Charout," = "
lRe2:   
   call Locate 11,04
   call Charout,"                                                          "
   call Locate 11,04
   call Charout,"(3)     Realteil (Re2) = "; pull Re2
   if DataType(Re2, 'N')<>1 then
   do    
     Call Quatsch
     Call Loesch
     Call SysCurState ON
     signal lRe2
   end    
   if sch==1 then signal lkmpl2
lIm2:   
   call Locate 12,04
   call Charout,"                                                          "
   call Locate 12,04
   call Charout,"(4) Imaginrteil (Im2) = "; pull Im2
   if DataType(Im2, 'N')<>1 then
   do    
     Call Quatsch
     Call Loesch
     Call SysCurState ON
     signal lIm2
   end    
lkmpl2:   
   svz2="+"
   if Im2>0 then do; svz2="+"; vz2=+1; end
   if Im2<0 then do; svz2="-"; vz2=-1; end
   call Locate 09,29
   if Im2==0 then ImIm2=0; else ImIm2=vz2*Im2
   z2=Re2||" "||svz2||" i*"||ImIm2
   call CsrAttrib "High";   call Color "White"  
   call Charout,"                                               "
   call Locate 09,29
   call Charout,z2
   call CsrAttrib "Normal"
   if sch==1 then Signal sel 

   
lop:    
   call Locate 14,04
   call Charout,"                                                         "
   call Locate 14,04
   call Charout,"(5) Operator (+,-,* oder /) : "; pull op
   op=ZRweg(op)
   
   if op<>"+" & op<>"-" & op<>"*" & op<>"/" then
   do
     Beep(250, 200)
     Signal lop
   end
   call Locate 14,34
   call CsrAttrib "High";   call Color "Cyan"  
   call Charout,op
   call CsrAttrib "Normal"
   if sch==1 then Signal sel

lnd:
   call Locate 15,04
   call Charout,"                                                         "
   call Locate 15,04
   call Charout,"(6) Wieviel Dezimalstellen  : "; pull ND
   if ND<4 | ND>54 then
   do    
     Beep(250, 200)
     Signal lnd
   end
   call Locate 15,34
   call CsrAttrib "High";   call Color "Cyan"  
   call Charout,ND
   call CsrAttrib "Normal"
   if sch==1 then Signal sel

sel:   
   call Locate 17,04 
   call Charout,"Bei nderungswunsch (1,2,3,4,5,6), sonst nur Eingabetaste " 
   call Locate 17,62 
   call Charout,"                 "
   call Locate 17,62 
   pull ent
 
   select 
      when ent=='1' then do; sch=1; Signal lRe1; end
      when ent=='2' then do; sch=1; Signal lIm1; end
      when ent=='3' then do; sch=1; Signal lRe2; end
      when ent=='4' then do; sch=1; Signal lIm2; end
      when ent=='5' then do; sch=1; Signal lop;  end
      when ent=='6' then do; sch=1; Signal lnd;  end
      when ent==''  then do; sch=1; Signal we1;  end
      otherwise 
      do
        Call SysCurState OFF
        Beep(444, 200); Beep(628,300)  
        Call SysCurState ON
        Signal sel
      end
   end
we1:   
   
   Numeric Digits ND+15
                  
   if op=='+' then
   do
     Re=Re1+Re2; Im=Im1+Im2
     signal Ausdr
   end

   if op=='-' then
   do
     Re=Re1-Re2; Im=Im1-Im2
     signal Ausdr
   end

   if op=='*' then
   do
     Re=Re1*Re2-Im1*Im2; Im=Re1*Im2+Re2*Im1
     signal Ausdr
   end
                               
   if op=='/' then
   do
     nen=Re2**2+Im2**2  /* Dieser Nenner ist immer grer als Null ! */
     Re=(Re1*Re2+Im1*Im2)/nen
     Im=(Im1*Re2-Re1*Im2)/nen
     signal Ausdr
   end
   
Ausdr:
   call Locate 19,04
   call CsrAttrib "High";   call Color "Yellow"  
   call Charout,"Re + i*Im"
   call CsrAttrib "Normal"
   call Charout," = "
   call CsrAttrib "High";   call Color "White"  
   call Charout,"(Re1 + i*Im1)"
   call CsrAttrib "High";   call Color "Cyan"  
   call Charout,op
   call CsrAttrib "High";   call Color "White"  
   call Charout,"(Re2 + i*Im2)" 
   call Locate 21,04
   call CsrAttrib "High";   call Color "Yellow"  
   call Charout,"Re = "
   call Color "Green"
   call Charout,Format(Re,,,,0)
   call Locate 22,04
   call CsrAttrib "High";   call Color "Yellow"  
   call Charout,"Im = "
   call Color "Green"
   call Charout,Format(Im,,,,0)
   call CsrAttrib "Normal"
ltne:   
   call Locate 24,76
   call Charout,"      "
   call Locate 24,04
   call Charout,"Sollen "
   call CsrAttrib "High";   call Color "Yellow"  
   call Charout,"Re"
   call CsrAttrib "Normal"
   call Charout," und "
   call CsrAttrib "High";   call Color "Yellow"  
   call Charout,"Im"
   call CsrAttrib "Normal"
   call Charout," fr weitere Rechnungen verwendet werden ? (J,n)"
   call Locate 24,69
   pull tne
   
   select 
      when tne=='' then do; Signal mehr; end
      when tne=='N' then 
                      do
                        call Locate 24,00
                        Signal PgmEnd
                      end
      otherwise
      do
        Call SysCurState OFF
        Beep(444, 200); Beep(628,300)  
        Call SysCurState ON
        Signal ltne
      end
   end
                  
mehr:      
   
   Numeric Digits ND+15
   
   /* Mathematische Konstanten */
   pi=3.1415926535897932384626433832795028841971693993751058209749445923078
   /* ln10 = ln(10) */
   ln10=2.3025850929940456840179914546843642076011014886287729760333279009675
   /*  m10 = 1/ln(10) */
   m10=0.434294481903251827651128918916605082294397005803666566114453783165
            
andere:
   call SysCls
   call Locate 02,04
   call CsrAttrib "High";   call Color "Yellow"  
   call Charout,"Re = "
   call Color "Green"
   call Charout,Format(Re,,,,0)
   call Locate 03,04
   call CsrAttrib "High";   call Color "Yellow"  
   call Charout,"Im = "
   call Color "Green"
   call Charout,Format(Im,,,,0)
   call CsrAttrib "Normal"
   
   call Locate 05,03
   call Charout,"(1)  z = (Re + i*Im)^y"
   call Locate 06,03
   call Charout,"(2)  z = exp(Re + i*Im)"
   call Locate 07,03
   call Charout,"(3)  z =  b^(Re + i*Im)"
   call Locate 08,03
   call Charout,"(4)  z =  ln(Re + i*Im)"
   call Locate 09,03
   call Charout,"(5)  z = log(Re + i*Im)"
   call Locate 10,03
   call Charout,"(6)  z =               "
   call Locate 11,03
   call Charout,"(7)  z =               "
   call Locate 12,03
   call Charout,"(8)  z =               "
   call Locate 13,03
   call Charout,"(9)  z =               "
   call Locate 14,02
   call Charout,"(10)  z =               "
                     
   call Locate 05,42
   call Charout,"(11)  z =  sin(Re + i*Im)"
   call Locate 06,42
   call Charout,"(12)  z =  cos(Re + i*Im)"
   call Locate 07,42
   call Charout,"(13)  z =  tan(Re + i*Im)"
   call Locate 08,42
   call Charout,"(14)  z =  cot(Re + i*Im)"
   call Locate 09,42
   call Charout,"(15)  z = sinh(Re + i*Im)"
   call Locate 10,42
   call Charout,"(16)  z = cosh(Re + i*Im)"
   call Locate 11,42
   call Charout,"(17)  z = tanh(Re + i*Im)"
   call Locate 12,42
   call Charout,"(18)  z = coth(Re + i*Im)"
   call Locate 13,42
   call Charout,"(19)  z =                "
   call Locate 14,42
   call Charout,"(20)  Programm verlassen "
                                              
lfu:                                              
   call Locate 16,71
   call Charout,"         "
   call Locate 16,04
   call Charout,"Welche Funktion soll berechnet werden ? Ziffer (1 bis 20)",
                "eingeben:"
   call Locate 16,72
   pull fu
       
   select
      when fu='1'  then do; Signal hochl;  end
      when fu='2'  then do; Signal expl;   end
      when fu='3'  then do; Signal hbhl;   end
      when fu='4'  then do; Signal lnlnl;  end
      when fu='5'  then do; Signal logl;   end
      when fu='6'  then do; Signal lab6;   end
      when fu='7'  then do; Signal lab7;   end
      when fu='8'  then do; Signal lab8;   end
      when fu='9'  then do; Signal lab9;   end
      when fu='10' then do; Signal lab10;  end
      when fu='11' then do; Signal sinl;   end
      when fu='12' then do; Signal cosl;   end
      when fu='13' then do; Signal tanl;   end
      when fu='14' then do; Signal cotl;   end
      when fu='15' then do; Signal sinhl;  end
      when fu='16' then do; Signal coshl;  end
      when fu='17' then do; Signal tanhl;  end
      when fu='18' then do; Signal cothl;  end
      when fu='19' then do; Signal lab19;  end
      when fu='20' then do; Signal PgmEnd; end
      otherwise                               
      do                                      
        Call SysCurState OFF
        Beep(444, 200); Beep(628,300)  
        Call SysCurState ON
        Signal lfu
      end                                     
   end     
                       
hochl:
   call SysCls
   call Locate 02,04
   call Charout,"Berechnung der Funktion "
   call CsrAttrib "High";   call Color "white"  
   call Charout,"(Re + i'Im)^(y)"
   call Locate 04,04
   call Charout,"Re = "
   call Color "yellow"
   call Charout,Format(Re,,,,0)
   call Locate 05,04
   call CsrAttrib "High";   call Color "white"  
   call Charout,"Im = "
   call Color "yellow"
   call Charout,Format(Im,,,,0)
   call CsrAttrib "Normal"
neuExp:   
   call Locate 06,04
   call Charout,"                                                        "
   call Locate 06,04
   call Charout,"Exponent  y  : "; pull yy
   st="y="yy
   interpret st
   
   if DataType(y, 'N')<>1 then
   do
     call nono
     call Loesch
     signal neuexp
   end
   
  /* Berechnung des Winkels */
  
   if Re>0 & Im==0 then 
   do   
     phi=0
     signal w11
   end

   if Re<0 & Im==0 then 
   do   
     phi=pi
     signal w11
   end

   if Re==0 & Im>0 then 
   do   
     phi=Pi/2
     signal w11
   end

   if Re==0 & Im<0 then 
   do   
     phi=-Pi/2
     signal w11
   end

     argu=Im/Re
     d=0_arctan(argu, ND)
     /* Zuordnung des ArcusTangens-Wertes in den Quadranten */ 
     if Re>0 & Im>0 then do; phi=d;    Signal w11; end 
     if Re<0 & Im>0 then do; phi=d+pi; Signal w11; end 
     if Re<0 & Im<0 then do; phi=d-pi; Signal w11; end 
     if Re>0 & Im<0 then do; phi=d;    Signal w11; end 
w11: 
  
  /* Berechnung des Betrages */
   betrQ=Re**2+Im**2   
   betr=0_sqrt(betrQ, ND)
   u=0_exp(y*0_ln(betr,ND),ND)
  /* Berechnung der Winkelfunktionen */
   phipot=y*phi  
   Recos=0_cos(phipot,ND)
   IMsin=0_sin(phipot,ND)
  /* Berechnung der Komponenten */
   Re1Erg=u*Recos   
   Im1Erg=u*Imsin   

   call Ergebnis "(Re + i*Im)^("yy")", Re1Erg, Im1Erg, ND 
   call Auswahl
   signal PgmEnd
                                
expl:
   call SysCls
   call Locate 02,04
   call Charout,"Berechnung der Funktion "
   call CsrAttrib "High";   call Color "white"  
   call Charout,"exp(Re + i*Im)"
   call Locate 04,04
   call Charout,"Re = "
   call Color "yellow"
   call Charout,Format(Re,,,,0)
   call Locate 05,04
   call CsrAttrib "High";   call Color "white"  
   call Charout,"Im = "
   call Color "yellow"
   call Charout,Format(Im,,,,0)
   call CsrAttrib "Normal"

  /* Berechnung des Betrages */
   u=0_exp(Re,ND)
  /* Berechnung der Winkelfunktionen */
   Recos=0_cos(Im,ND)
   IMsin=0_sin(Im,ND)
  /* Berechnung von Real- und Imaginrteil */
   Re2Erg=u*Recos   
   Im2Erg=u*Imsin   
  
   call Ergebnis "exp(Re + i*Im)", Re2Erg, Im2Erg, ND 
   call Auswahl
   signal PgmEnd
  
  
hbhl:
   call SysCls
   call Locate 02,04
   call Charout,"Berechnung der Funktion "
   call CsrAttrib "High";   call Color "white"  
   call Charout,"b^(Re + i*Im)"
   call Locate 04,04
   call Charout,"Re = "
   call Color "yellow"
   call Charout,Format(Re,,,,0)
   call Locate 05,04
   call CsrAttrib "High";   call Color "white"  
   call Charout,"Im = "
   call Color "yellow"
   call Charout,Format(Im,,,,0)
   call CsrAttrib "Normal"
neuhbhl:   
   call Locate 06,04
   call Charout,"                                                        "
   call Locate 06,04
   call Charout,"Basis  b  : "; pull bb
   st="b="bb
   interpret st
   
   if DataType(b, 'N')<>1 then
   do
     call nono
     call Loesch
     signal neuhbhl
   end
                    
  /* Berechnung des Betrages */
   u=0_exp(Re*0_ln(b,ND),ND)
  /* Berechnung der Winkelfunktionen */
   Recos=0_cos(Im*0_ln(b,ND),ND)
   IMsin=0_sin(Im*0_ln(b,ND),ND)
  /* Berechnung von Real- und Imaginrteil */
   Re3Erg=u*Recos   
   Im3Erg=u*Imsin   
      
   call Ergebnis "("bb")^(Re + i*Im)", Re3Erg, Im3Erg, ND 
   call Auswahl
   signal PgmEnd
   
lnlnl:
   call SysCls
   call Locate 02,04
   call Charout,"Berechnung der Funktion "
   call CsrAttrib "High";   call Color "white"  
   call Charout,"ln(Re + i*Im)"
   call Locate 04,04
   call Charout,"Re = "
   call Color "yellow"
   call Charout,Format(Re,,,,0)
   call Locate 05,04
   call CsrAttrib "High";   call Color "white"  
   call Charout,"Im = "
   call Color "yellow"
   call Charout,Format(Im,,,,0)
   call CsrAttrib "Normal"

  /* Berechnung des Winkels */
   
   if Re>0 & Im==0 then 
   do   
     phi=0
     signal w41
   end

   if Re<0 & Im==0 then 
   do   
     phi=pi
     signal w41
   end

   if Re==0 & Im>0 then 
   do   
     phi=Pi/2
     signal w41
   end

   if Re==0 & Im<0 then 
   do   
     phi=-Pi/2
     signal w41
   end

     argu=Im/Re
     d=0_arctan(argu, ND)
     /* Zuordnung des ArcusTangens-Wertes in den Quadranten */ 
     if Re>0 & Im>0 then do; phi=d;    Signal w41; end 
     if Re<0 & Im>0 then do; phi=d+pi; Signal w41; end 
     if Re<0 & Im<0 then do; phi=d-pi; Signal w41; end 
     if Re>0 & Im<0 then do; phi=d;    Signal w41; end 
w41:
     
  /* Berechnung des Betrages */
   betrQ=Re**2+Im**2   
   betr=0_sqrt(betrQ, ND)
   u=0_ln(betr, ND)
  /* Berechnung der Komponenten */
   Re4Erg=u   
   Im4Erg=phi   
  
   call Ergebnis "ln(Re + i*Im)", Re4Erg, Im4Erg, ND 
   call Auswahl
   signal PgmEnd
   
logl:
   call SysCls
   call Locate 02,04
   call Charout,"Berechnung der Funktion "
   call CsrAttrib "High";   call Color "white"  
   call Charout,"log(Re + i*Im)"
   call Locate 04,04
   call Charout,"Re = "
   call Color "yellow"
   call Charout,Format(Re,,,,0)
   call Locate 05,04
   call CsrAttrib "High";   call Color "white"  
   call Charout,"Im = "
   call Color "yellow"
   call Charout,Format(Im,,,,0)
   call CsrAttrib "Normal"

  /* Berechnung des Winkels */
      
   if Re>0 & Im==0 then 
   do   
     phi=0
     signal w51
   end

   if Re<0 & Im==0 then 
   do   
     phi=pi
     signal w51
   end

   if Re==0 & Im>0 then 
   do   
     phi=Pi/2
     signal w51
   end

   if Re==0 & Im<0 then 
   do   
     phi=-Pi/2
     signal w51
   end

     argu=Im/Re
     d=0_arctan(argu, ND)
     /* Zuordnung des ArcusTangens-Wertes in den Quadranten */ 
     if Re>0 & Im>0 then do; phi=d;    Signal w51; end 
     if Re<0 & Im>0 then do; phi=d+pi; Signal w51; end 
     if Re<0 & Im<0 then do; phi=d-pi; Signal w51; end 
     if Re>0 & Im<0 then do; phi=d;    Signal w51; end 
w51:
      
  /* Berechnung des Betrages */
   betrQ=Re**2+Im**2   
   betr=0_sqrt(betrQ, ND)
   u=0_ln(betr, ND)
  /* Berechnung der Komponenten */
   Re5Erg=u*m10   
   Im5Erg=phi*m10   
  
   call Ergebnis "log(Re + i*Im)", Re5Erg, Im5Erg, ND 
   call Auswahl
   signal PgmEnd
   
lab6:   
   call NochNicht
   call Loesch
   signal lfu
  
lab7:   
   call NochNicht
   call Loesch
   signal lfu
   
lab8:   
   call NochNicht
   call Loesch
   signal lfu
   
lab9:     
   call NochNicht
   call Loesch
   signal lfu
     
lab10:     
   call NochNicht
   call Loesch
   signal lfu
     
sinl:                                              
   call SysCls
   call Locate 02,04
   call Charout,"Berechnung der Funktion "
   call CsrAttrib "High";   call Color "white"  
   call Charout,"sin(Re + i*Im)"
   call Locate 04,04
   call Charout,"Re = "
   call Color "yellow"
   call Charout,Format(Re,,,,0)
   call Locate 05,04
   call CsrAttrib "High";   call Color "white"  
   call Charout,"Im = "
   call Color "yellow"
   call Charout,Format(Im,,,,0)
   call CsrAttrib "Normal"
     
  /* Berechnung der Komponenten */
   Re11Erg=0_sin(Re,ND)*0_cosh(Im,ND)   
   Im11Erg=0_cos(Re,ND)*0_sinh(Im,ND)   
  
   call Ergebnis "sin(Re + i*Im)", Re11Erg, Im11Erg, ND 
   call Auswahl
   signal PgmEnd
   
cosl:   
   call SysCls
   call Locate 02,04
   call Charout,"Berechnung der Funktion "
   call CsrAttrib "High";   call Color "white"  
   call Charout,"cos(Re + i*Im)"
   call Locate 04,04
   call Charout,"Re = "
   call Color "yellow"
   call Charout,Format(Re,,,,0)
   call Locate 05,04
   call CsrAttrib "High";   call Color "white"  
   call Charout,"Im = "
   call Color "yellow"
   call Charout,Format(Im,,,,0)
   call CsrAttrib "Normal"
     
  /* Berechnung der Komponenten */
   Re12Erg=0_cos(Re,ND)*0_cosh(Im,ND)   
   Im12Erg=-0_sin(Re,ND)*0_sinh(Im,ND)   
  
   call Ergebnis "cos(Re + i*Im)", Re12Erg, Im12Erg, ND 
   call Auswahl
   signal PgmEnd
       
tanl:                                              
   call SysCls
   call Locate 02,04
   call Charout,"Berechnung der Funktion "
   call CsrAttrib "High";   call Color "white"  
   call Charout,"tan(Re + i*Im)"
   call Locate 04,04
   call Charout,"Re = "
   call Color "yellow"
   call Charout,Format(Re,,,,0)
   call Locate 05,04
   call CsrAttrib "High";   call Color "white"  
   call Charout,"Im = "
   call Color "yellow"
   call Charout,Format(Im,,,,0)
   call CsrAttrib "Normal"
     
  /* Berechnung der Komponenten */
   Nen13=0_cos(2*Re,ND)+0_cosh(2*Im,ND)
   if Nen13==0 then
   do   
     call Quatsch000
     call Loesch
     Call SysCurState ON
     call SysCls
     signal Anf
   end
   Re13Erg=0_sin(2*Re,ND)/Nen13   
   Im13Erg=0_sinh(2*Im,ND)/Nen13   
  
   call Ergebnis "tan(Re + i*Im)", Re13Erg, Im13Erg, ND 
   call Auswahl
   signal PgmEnd

cotl:
   call SysCls
   call Locate 02,04
   call Charout,"Berechnung der Funktion "
   call CsrAttrib "High";   call Color "white"  
   call Charout,"cot(Re + i*Im)"
   call Locate 04,04
   call Charout,"Re = "
   call Color "yellow"
   call Charout,Format(Re,,,,0)
   call Locate 05,04
   call CsrAttrib "High";   call Color "white"  
   call Charout,"Im = "
   call Color "yellow"
   call Charout,Format(Im,,,,0)
   call CsrAttrib "Normal"
     
  /* Berechnung der Komponenten */
   Nen14=0_cosh(2*Im,ND)-0_cos(2*Re,ND)
   if Nen14==0 then
   do   
     call Quatsch000
     call Loesch
     Call SysCurState ON
     call SysCls
     signal Anf
   end
   Re14Erg=0_sin(2*Re,ND)/Nen14   
   Im14Erg=-0_sinh(2*Im,ND)/Nen14   
  
   call Ergebnis "cot(Re + i*Im)", Re14Erg, Im14Erg, ND 
   call Auswahl
   signal PgmEnd
   
sinhl:
   call SysCls
   call Locate 02,04
   call Charout,"Berechnung der Funktion "
   call CsrAttrib "High";   call Color "white"  
   call Charout,"sinh(Re + i*Im)"
   call Locate 04,04
   call Charout,"Re = "
   call Color "yellow"
   call Charout,Format(Re,,,,0)
   call Locate 05,04
   call CsrAttrib "High";   call Color "white"  
   call Charout,"Im = "
   call Color "yellow"
   call Charout,Format(Im,,,,0)
   call CsrAttrib "Normal"
     
  /* Berechnung der Komponenten */
   Re15Erg=0_sinh(Re,ND)*0_cos(Im,ND) 
   Im15Erg=0_cosh(Re,ND)*0_sin(Im,ND)   
  
   call Ergebnis "sinh(Re + i*Im)", Re15Erg, Im15Erg, ND 
   call Auswahl
   signal PgmEnd
                                        
coshl:                              
   call SysCls
   call Locate 02,04
   call Charout,"Berechnung der Funktion "
   call CsrAttrib "High";   call Color "white"  
   call Charout,"cosh(Re + i*Im)"
   call Locate 04,04
   call Charout,"Re = "
   call Color "yellow"
   call Charout,Format(Re,,,,0)
   call Locate 05,04
   call CsrAttrib "High";   call Color "white"  
   call Charout,"Im = "
   call Color "yellow"
   call Charout,Format(Im,,,,0)
   call CsrAttrib "Normal"
     
  /* Berechnung der Komponenten */
   Re16Erg=0_cosh(Re,ND)*0_cos(Im,ND)   
   Im16Erg=0_sinh(Re,ND)*0_sin(Im,ND)   
  
   call Ergebnis "cosh(Re + i*Im)", Re16Erg, Im16Erg, ND 
   call Auswahl
   signal PgmEnd
   
tanhl:                                  
   call SysCls
   call Locate 02,04
   call Charout,"Berechnung der Funktion "
   call CsrAttrib "High";   call Color "white"  
   call Charout,"tanh(Re + i*Im)"
   call Locate 04,04
   call Charout,"Re = "
   call Color "yellow"
   call Charout,Format(Re,,,,0)
   call Locate 05,04
   call CsrAttrib "High";   call Color "white"  
   call Charout,"Im = "
   call Color "yellow"
   call Charout,Format(Im,,,,0)
   call CsrAttrib "Normal"
     
  /* Berechnung der Komponenten */
   Nen17=0_cosh(2*Re,ND)+0_cos(2*Im,ND)
   if Nen17==0 then
   do   
     call Quatsch000
     call Loesch
     Call SysCurState ON
     call SysCls
     signal Anf
   end
   Re17Erg=0_sinh(2*Re,ND)/Nen17   
   Im17Erg=0_sin(2*Im,ND)/Nen17   
  
   call Ergebnis "tanh(Re + i*Im)", Re17Erg, Im17Erg, ND 
   call Auswahl
   signal PgmEnd
   
      
cothl:      
   call SysCls
   call Locate 02,04
   call Charout,"Berechnung der Funktion "
   call CsrAttrib "High";   call Color "white"  
   call Charout,"coth(Re + i*Im)"
   call Locate 04,04
   call Charout,"Re = "
   call Color "yellow"
   call Charout,Format(Re,,,,0)
   call Locate 05,04
   call CsrAttrib "High";   call Color "white"  
   call Charout,"Im = "
   call Color "yellow"
   call Charout,Format(Im,,,,0)
   call CsrAttrib "Normal"
     
  /* Berechnung der Komponenten */
   Nen18=0_cosh(2*Re,ND)-0_cos(2*Im,ND)
   if Nen18==0 then
   do   
     call Quatsch000
     call Loesch
     Call SysCurState ON
     call SysCls
     signal Anf
   end
   Re18Erg=0_sinh(2*Re,ND)/Nen18   
   Im18Erg=-0_sin(2*Im,ND)/Nen18   
  
   call Ergebnis "coth(Re + i*Im)", Re18Erg, Im18Erg, ND 
   call Auswahl
   signal PgmEnd
      
lab19:      
   call NochNicht
   call Loesch                                      
   signal lfu
      
PgmEnd:
   Call CsrAttrib "Normal"
EXIT

/******************* Eigene Prozeduren und Funktionen **********************/
   
ZRweg:                     
  arg st
  do forever
    lzw=Pos(" ", st)
    if lzw = 0 then leave
    st=DelStr(st,lzw,1)
  end  
  return(st)
                     
Quatsch:  
   Call SysCurState OFF
nono:   
   call CsrAttrib "High";   call Color "cyan","cyan"
   call Locate 20,03
   say"ͻ"
   call Locate 21,03
   say"                                                                         "
   call Locate 22,03
   say"                                                                         "
   call Locate 23,03
   say"                                                                         "
   call Locate 24,03
   say"ͼ"
   call Locate 22,12
   call Charout,"!! Der eingegebene String ist keine gltige REXX-Zahl !!"                              
   call Locate 24,24
   call Color "Green","Green"
   call Charout," Zurck mit der Eingabetaste "
   Beep(444, 200); Beep(628,300) 
   pull q
   if q<>" " then
   do 
     call Locate 24,24
     call Charout," "
     Signal nono
   end    
   call CsrAttrib "Normal"
   return                              
  
NochNicht:  
   call CsrAttrib "High";   call Color "cyan","cyan"
   call Locate 20,03
   say"ͻ"
   call Locate 21,03
   say"                                                                         "
   call Locate 22,03
   say"                                                                         "
   call Locate 23,03
   say"                                                                         "
   call Locate 24,03
   say"ͼ"
   call Locate 22,16
   call Charout,"!! Hier ist noch keine Funktion implementiert !!"
   call Locate 24,24
   call Color "Green","Green"
   call Charout," Zurck mit der Eingabetaste "
   Beep(444, 200); Beep(628,300) 
   pull q
   
   if Datatype(q, 'N')<>1 then
   do 
     call Locate 24,24
     call Charout," "
     call CsrAttrib "Normal"
     Signal Loesch
   end    
   call CsrAttrib "Normal"
   call Loesch 
   signal lfu
   return
                     
Loesch:  
   call Locate 19,03
   call Locate 20,03
   say"                                                                           "
   call Locate 21,03
   say"                                                                           "
   call Locate 22,03
   say"                                                                           "
   call Locate 23,03
   say"                                                                           "
   call Locate 24,03
   say"                                                                           "
   call Locate 22,12
   return                              
       
   
Quatsch0:  
   Call SysCurState OFF
nono:   
   call CsrAttrib "High";   call Color "cyan","cyan"
   call Locate 20,03
   say"ͻ"
   call Locate 21,03
   say"                                                                         "
   call Locate 22,03
   say"                                                                         "
   call Locate 23,03
   say"                                                                         "
   call Locate 24,03
   say"ͼ"
   call Locate 22,16
   call Charout,"!! Man darf doch nicht durch Null dividieren !!"                              
   call Locate 24,24
   call Color "Green","Green"
   call Charout," Zurck mit der Eingabetaste "
   Beep(444, 200); Beep(628,300) 
   pull q
   if q<>" " then
   do 
     call Locate 24,24
     call Charout," "
     Signal nono
   end    
   call CsrAttrib "Normal"
   return                              
   
Quatsch000:  
   Call SysCurState OFF
toto:   
   call CsrAttrib "High";   call Color "cyan","cyan"
   call Locate 19,03
   say"ͻ"
   call Locate 20,03
   say"                                                                         "
   call Locate 21,03
   say"                                                                         "
   call Locate 22,03
   say"                                                                         "
   call Locate 23,03
   say"                                                                         "
   call Locate 24,03
   say"ͼ"
   call Locate 21,15
   call Charout,"!! Im Verlauf der Berechnung des Funktionswertes !!"
   call Locate 22,20
   call Charout,"!! ist ein Nenner gleich Null gewesen !!"
   call Locate 24,24
   call Color "Green","Green"
   call Charout," Zurck mit der Eingabetaste "
   Beep(444, 200); Beep(628,300) 
   pull q
   if q<>" " then
   do 
     call Locate 24,24
     call Charout," "
   Signal toto 
   end    
   call CsrAttrib "Normal"
   return                              
   
Ergebnis: /* Diese Prozedur kann alle Ergebnisse ausgeben. */
   parse arg st1,ReErg,ImErg,ND
   call Locate 08,04
   call Charout,"Die Komponenten der komplexen Zahl"
   call CsrAttrib "High";  call Color "yellow" 
   call Locate 10,04
   call Charout,st1
   call CsrAttrib "Normal"
   call Locate 12,04
   call Charout,"sind:"
   call CsrAttrib "High";  call Color "white"  
   call Locate 14,04
   call Charout,"Realteil     "
   call CsrAttrib "Normal"
   call Charout," = "
   call CsrAttrib "High";  call Color "cyan"
   call Charout,Format(ReErg,,ND, ,10)
   call Locate 15,04       
   call Color "white"
   call Charout,"Imaginrteil "
   call CsrAttrib "Normal"
   call Charout," = "
   call CsrAttrib "High";  call Color "cyan"
   call Color "cyan"
   call Charout,Format(ImErg,,ND, ,10)
   call Locate 17,04
   call CsrAttrib "Normal"
   call Charout,"========================================================="
   call Locate 19,04
   call Charout,"Soll von der komplexen Zahl " 
   call CsrAttrib "High";   call Color "white"  
   call Charout,"(Re + i*Im) " 
   call CsrAttrib "Normal"
   call Charout,"mit den Komponenten" 
   call Locate 21,04
   call CsrAttrib "High";   call Color "white"  
   call Charout,"Re = "
   call Color "yellow"
   call Charout,Format(Re,,,,0)
   call Locate 22,04
   call CsrAttrib "High";   call Color "white"  
   call Charout,"Im = "
   call Color "yellow"
   call Charout,Format(Im,,,,0)
   call CsrAttrib "Normal"
   return
       

Auswahl:
q3q:   
   call Locate 24,50
   call Charout,"                           "   
   call Locate 24,04
   call Charout,"eine andere Funktion berechnet werden ? (J,n) "   
   call Locate 24,50; pull qqq 
                 
   select
      when qqq=='' then do; Signal andere; end
      when qqq=='N' then do; Signal PgmEnd; end
      otherwise
      do
        Call SysCurState OFF
        Beep(444, 200); Beep(628,300)  
        Call SysCurState ON
        signal q3q
      end
   end
   return                             

Fehlermeldung:             
   call CsrAttrib "High";   call Color "cyan","cyan"
   call Locate 20,03
   say"ͻ"
   call Locate 21,03
   say"                                                                         "
   call Locate 22,03
   say"                                                                         "
   call Locate 23,03
   say"                                                                         "
   call Locate 24,03
   say"ͼ"
   call Locate 22,12
   call Charout,"!! Der eingegebene String ist keine gltige REXX-Zahl !!"                              
   call Locate 24,24
   call Color "Green","Green"
   call Charout," Zurck mit der Eingabetaste "
   Beep(444, 200); Beep(628,300) 
   pull q
   if q<>" " then
   do 
     call Locate 24,24
     call Charout," "
     Signal nono
   end    
   call CsrAttrib "Normal"
   return                              
                           
kmplMsg:                           
   Call SysCurState OFF
tutu:   
   call CsrAttrib "High";   call Color "cyan","cyan"
   call Locate 11,03
   say"ͻ"
   call Locate 12,03
   say"                                                                         "
   call Locate 13,03
   say"                                                                         "
   call Locate 14,03
   say"                                                                         "
   call Locate 15,03
   say"                                                                         "
   call Locate 16,03
   say"                                                                         "
   call Locate 17,03
   say"                                                                         "
   call Locate 18,03
   say"                                                                         "
   call Locate 19,03
   say"                                                                         "
   call Locate 20,03
   say"                                                                         "
   call Locate 21,03
   say"                                                                         "
   call Locate 22,03
   say"                                                                         "
   call Locate 23,03
   say"                                                                         "
   call Locate 24,03
   say"ͼ"
   call Locate 13,10
   call Charout,"Im Verlauf der Berechnung des Funktionswertes"
   call Locate 14,10
   call Charout,"entweder"
   call Locate 16,10
   call Charout,"ein Nenner gleich Null gewesen oder"
   call Locate 17,10
   call Charout,"ein Funktionsargument auerhalb des zulssigen Bereichs gewesen."
   call Locate 19,10
   call Charout,"Angaben ber die zulssigen Bereichsgrenzen von Variablen"
   call Locate 20,10
   call Charout,"als Funktionsargumente finden Sie in der Datei kmpl.INF !"
   call Locate 24,24
   call Color "Green","Green"
   call Charout," Weiter mit der Eingabetaste "
   Beep(444, 200); Beep(628,300) 
   pull q
   if q<>" " then
   do 
     call Locate 24,24
     call Charout," "
   Signal tutu 
   end    
   call CsrAttrib "Normal"
   call SysCls
   "start /PM /Max C:\OS2\VIEW.EXE "pfd"KMPL.INF"
   return     
   
                            
/*---------------------------- ANSI-Prozeduren ----------------------------*/
/* Ansi Procedures for moving the cursor */
Locate: Procedure   /*  Call Locate Row,Col */
Row = arg(1)
Col = Arg(2)
Rc = Charout(,D2C(27)"["Row";"col"H")
return ""

CsrUp: Procedure  /* CsrUp(Rows) */
Arg u
Rc = Charout(,D2C(27)"["u"A")
return ""

CsrDown: Procedure /* CsrDn(Rows) */
Arg d
Rc = Charout(,D2C(27)"["d"B")
return ""

CsrRight: Procedure  /* CsrRight(Cols) */
arg r
Rc = Charout(,D2C(27)"["r"C")
Return ""

CsrLeft: procedure  /* CsrLeft(Cols) */
arg l
Rc = Charout(,D2C(27)"["l"D")
Return ""


/*
A------------------------------------------------------------:*
SaveCsr and PutCsr are meant to be used together for saving  :*
and restoring the cursor location. Do not confuse            :*
with Locate, CsrRow, CsrCol, these are different routines.   :*
SaveCsr Returns a string that PutCsr can use.                :*
A:*/
SaveCsr: procedure  /* cursor_location = SaveCsr() (for PutCsr(x))*/
Rc = Charout(,D2C(27)"[6n")
Pull Q
Call CsrUp
return Q

PutCsr: procedure  /* Call PutCsr <Previous_Location>  (From SaveCsr() ) */
Where = arg(1)
Rc = Charout(,substr(Where,1,7)"H")
return ""
/*
A:*/
/* clear screen :*/
Cls: Procedure      /* cls() Call Cls */
Rc = CharOut(,D2C(27)"[2J")
return ""

    /* get cursors Line */
CsrRow: Procedure      /* Row = CsrRow()*/
Rc = Charout(,D2C(27)"[6n")
Pull Q
Return substr(Q,3,2)

   /* get cursors column */
CsrCol: Procedure          /*  Col = CsrCol()  */
Rc = Charout(,D2C(27)"[6n")
Pull Q
return Substr(Q,6,2)

/* procedure to color screen
A:--------------------------------------------------------------*
accepts colors: BLACK RED GREEN YELLOW BLUE MAGENTA CYAN WHITE  *
*/
Color: Procedure /* Call Color <ForeGround>,<BackGround> */
arg F,B
Colors = "BLACK RED GREEN YELLOW BLUE MAGENTA CYAN WHITE"
return CHAROUT(,D2C(27)"["WORDPOS(F,COLORS)+29";"WORDPOS(B,COLORS)+39";m")

/*  change screen attributes
A:---------------------------------------------------------------*
attributes: NORMAL HIGH LOW ITALIC UNDERLINE BLINK RAPID REVERSE *
*/
CsrAttrib: Procedure  /* call CsrAttrib <Attrib> */
Arg A
attr = "NORMAL HIGH LOW ITALIC UNDERLINE BLINK RAPID REVERSE"
return CHAROUT(,D2C(27)"["WORDPOS(A,ATTR) - 1";m")

EndAll:
Call Color "White","Black"
CALL CsrAttrib "Normal"
